{--------------------------------------------------------}
{                                                        }
{    Programa de acesso a redes sociais                  }
{                                                        }
{    Mdulo de acesso ao protocolo twitter API           }
{                                                        }
{    Autor: Jos Antonio Borges                          }
{                                                        }
{    Em setembro/2010                                    }
{                                                        }
{--------------------------------------------------------}

unit twapi;

interface
uses
     dvcrt, dvwin, dvInet, dvSsl, winsock, sysutils, sha1, classes,
     twvars, twmsg, twOauth, twutil, twjson, SuperObject;

procedure mostraErroHTTP (resp: string);
function getFromTwitter (cmd: string; var resp: string): boolean;
function getFromTwitterMudo (cmd: string; var resp: string): boolean;
function postToTwitter (cmd, postData: string): boolean;
function requestToTwitter (cmd, postData: string; var resp: string): boolean;
function getTwitterUserInfo (comando: string): PUser;

implementation

procedure mostraErroHTTP (resp: string);
var
    obj: ISuperObject;
    erros: LErrors;
    i: integer;
    t: string;

begin
    obj := criaSuperObject (resp);
    erros := montaErrors (obj);
    for i := 0 to erros.count-1 do
        begin
            t := traduzErro(erros[i]);
            if copy (t, 1, 2) = 'TW' then mensagem (t, 1)
                                     else sintWriteln (t);
        end;

    pegaTextoMensagem ('TWERRO');     {'Erro no processamento.'}
    erros.free;
end;

{--------------------------------------------------------}

function getFromTwitter (cmd: string; var resp: string): boolean;
var
    status: integer;

begin
    mensagem ('TWSOLIC', 1); {'Solicitando... '}

    resp := getOauthTwitterRest (cmd, status);
    dump(cmd);
    dump(resp);

    if status <> 200 then
        begin
            result := false;
            if status = 404 then
                resp := '{"errors": [{"error": 404, "message":"Site do Twitter est invlido"}]}';

            mostraErroHttp (resp);
            exit;
        end;

    mensagem ('TWOK', 1);    {'Ok'}
    result := true;
end;

{--------------------------------------------------------}

function getFromTwitterMudo (cmd: string; var resp: string): boolean;
var
    status: integer;

begin
    resp := getOauthTwitterRest (cmd, status);
    dump(cmd);
    dump(resp);

    if status <> 200 then
        begin
            result := false;
            if status = 404 then
                resp := '{"errors": [{"error": 404, "message":"Site do Twitter est invlido"}]}';

            mostraErroHttp (resp);
            exit;
        end;

    result := true;
end;

{--------------------------------------------------------}

function postToTwitter (cmd, postData: string): boolean;
var status: integer;
    resp: string;
begin
    mensagem ('TWENVMSG', 1);   {'Enviando mensagem...'}

    resp := postOauthTwitterRest (cmd, postData, status);
    dump (resp);

    if status = 200 then
        begin
            mensagem ('TWMSGENV', 1);      {'Mensagem enviada.'}
            result := true;
        end
    else
        begin
            mensagem ('TWMSNENV', 1);     {'Mensagem no foi enviada.'}
            mostraErroHttp (resp);
            result := false;
        end;
end;

{--------------------------------------------------------}

function requestToTwitter (cmd, postData: string; var resp: string): boolean;
var status: integer;
begin
    mensagem ('TWSOLIC', 1);   {'Solicitando...'}

    resp := postOauthTwitterRest (cmd, postData, status);
    dump (resp);

    if status = 200 then
        begin
            mensagem ('TWOK', 1);      {'Ok.'}
            result := true;
        end
    else
        begin
            mostraErroHttp (resp);
            result := false;
        end;
end;

{--------------------------------------------------------}

function getTwitterUserInfo (comando: string): PUser;
var resp: string;
    status: integer;
    obj: ISuperObject;

begin
    mensagem ('TWSOLIC', 1);      {'Solicitando... '}

    resp := getOauthTwitterRest (comando, status);

    if status = 200 then
        begin
            mensagem ('TWOK', 1);    {'Ok'}
            dump (resp);
            obj := criaSuperObject (resp);
            result := montaUser (obj);
        end
    else
        begin
            mostraErroHTTP (resp);
            result := NIL;
        end;
end;

end.

