{--------------------------------------------------------}
{                                                        }
{    Programa de acesso a redes sociais                  }
{                                                        }
{    Exibidor de foto                                    }
{                                                        }
{    Autor: Jos Antonio Borges                          }
{                                                        }
{    Em setembro/2010                                    }
{                                                        }
{--------------------------------------------------------}

unit twimg;

interface
uses
    dvcrt, dvwin, dvInet, dvSsl, winsock, sysutils, jpeg,
    windows, classes, graphics, twvars;

procedure mostraImagem(url: string; x, y: integer);

implementation


procedure mostraNaTela (img: pbyte; ti: integer);
var
    FTela: TBitmap;
    FJpeg: TJPEGImage;
    Memdc, crtDC: hDC;
    arq: file;
    maxy, x, y, dx, dy: integer;
begin
    assignFile (arq, '$$$.jpg');
    rewrite (arq, 1);
    blockWrite (arq, img^, ti);
    closefile (arq);

    FJpeg := TJPEGImage.Create;
    FJpeg.loadFromFile('$$$.jpg');

    FTela := TBitmap.Create;
    FTela.Width := FJpeg.Width;
    FTela.Height := FJpeg.Height;
    FTela.PixelFormat := pf24bit;
    FTela.Canvas.Draw(0, 0, FJpeg);
    FJpeg.Free;

    crtDc := getDc (crtWindow);
    Memdc := CreateCompatibleDC (crtDc);
    SelectObject(MemDC, FTela.Handle);

    dx := Ftela.Width*10;
    dy := FTela.Height*10;
    maxy := (WindowSize.y div 25) * 5;
    while dy > maxy do
        begin
            dx := 2 * dx div 3;
            dy := 2 * dy div 3;
        end;
    x := WindowSize.x - dx - 2*WindowSize.y div 25;
    y := WindowSize.y - dy - 2*WindowSize.y div 25;

    StretchBlt(crtDc, x, y, dx, dy,
                      MemDC, 0, 0, Ftela.Width, Ftela.Height, SRCCopy);
    DeleteDC(MemDC);
    releaseDc (crtWindow, crtDc);

    FTela.Free;
    {$I-} Erase (arq); {$I+} ioresult;
end;

procedure mostraImagem(url: string; x, y: integer);
var
    sockHTTP: integer;
    schema, site, param, cmd, header, s: string;
    p, aReceber, i, ti: integer;
    c: char;
    status: integer;
    pbuf: pointer;
    img: array [0..100000] of byte;

label erroHTTP;
begin
    if (ansiUpperCase(copy (url, length(url)-3, 4)) <> '.JPG') and
       (ansiUpperCase(copy (url, length(url)-4, 5)) <> '.JPEG') then exit;

    p := pos(':', url);
    schema := copy (url, 1, p-1);
    delete (url, 1, p+2);
    p := pos ('/', url);
    site := copy (url, 1, p-1);
    delete (url, 1, p-1);
    param := url;

    if ansiUpperCase (schema) = 'HTTPS' then
        sockHTTP := abreConexaoSSL (site, 443)
    else
        sockHTTP := abreConexao (site, 80);
    if sockHTTP <= 0 then exit;

    cmd := 'GET ' + param + ' HTTP/1.0' + ^m^j +
        'Host: ' + site + ^m^j +
        'User-Agent: Twitvox' + ^m^j +
        ^m^j;

    sendBuf (sockHTTP, pchar(cmd), length(cmd), 0);

    pbuf := inicBufRede (sockHTTP);
    if not readlnBufRede (pbuf, header, 20) then goto erroHttp;

    delete (header, 1, pos(' ', header));
    delete (header, pos(' ', header), 999);
    try
        status := strToInt (trim(header));
    except
        status := -1;
    end;

    if status = -1 then goto erroHTTP;

    aReceber := 0;
    repeat
        if not readlnBufRede (pbuf, s, 10) then goto erroHttp;
        if copy (s, 1, 15) = 'Content-Length:' then
            aReceber := strToInt (trim(copy (s, 16, 999)));
    until s = '';

    ti := 0;
    for i := 1 to aReceber do
        begin
            if leCaracBufRede (pbuf, c) then
                begin
                    img[ti] := ord(c);
                    ti := ti + 1;
                end;
        end;

    fechaConexao(sockHTTP);
    mostraNaTela (@img, ti);
    exit;

erroHttp:
    fechaConexao(sockHTTP);
//    mensagem ('TWERHTTP', 1);  {'Erro no protocolo HTTP'}
end;

end.

